/*
    "partagette" est un systeme de déploiment de pages de fichiers numériques dans l'espace
    Gepeto@du-libre.org licence artlibre (http://artlibre.org)
    V 18 au 2/10/2018
    https://snhack.org/doku.php?id=projets:eparpillage
    https://bricoles.du-libre.org

  Base on FSWebServer - Example WebServer with SPIFFS backend for esp8266
  Copyright (c) 2015 Hristo Gochkov. All rights reserved.
  This file is part of the ESP8266WebServer library for Arduino environment.
  Add on with DNS lib captiv portal
  
  LIRE Note.h
  
  MAX_CONNEXION nbr de connexion simultanées max =5 (8 en theorie)
  INVISIBLE si 1 SSID invisible
  fichier /listfic.txt  liste des fichiers à récupérer
  Commandes    http://192.168.4.1/cmd? mode commandes
  /date donne heure
  /cmd_ftpon se mettre en mode ftp user pass def toto gnulinux
     et ftp -p 192.168.4.1
  /gpio_all donne l etat des gpio
  /fichier liste des fichiers de la flash
  /cmd?passglob=lebonmotdepasse  gnulinux entre en mode admin
  /cmd?format=""
  /cmd?reset="" // recupere les fichiers de la source
  /cmd?maj_heure=2018:08:16:18:39:00
  /cmd?info_conf=""
  /cmd?heure_ntp="" cherche le serveur ntp pour mise a l heure
  /cmd?ssid="nouveaussid" , idem avec pass , canal , sauve pour sauvegarder la config ???
*/
#define ESP8266
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266HTTPClient.h>
#include <ESP8266WebServer.h>
#include <DNSServer.h>
#include <WiFiUdp.h>
#include <FS.h>
#include <Ticker.h>
#include <Wire.h>
#include <TimeLib.h>
#include <RtcDS1307.h> // compatible avec TimeLib
#include <NTPClient.h>
#include <ESP8266FtpServer.h>
#include <ArduinoJson.h>

WiFiClient client;
ESP8266WebServer server(80);
RtcDS1307<TwoWire> Rtc(Wire);

DNSServer dnsServer;              // Create the DNS object
const byte DNS_PORT = 53;         // Capture DNS requests on port 53
/* Soft AP network parameters */
IPAddress apIP(192, 168, 4, 1);      // ip source
IPAddress serveurIP(192, 168, 4, 1); // retour du DNS
IPAddress netMsk(255, 255, 255, 0);
bool ftpon = false;
int essai_connexion = 0;
int status = WL_IDLE_STATUS;
int bouton_init = D8; // GPIO 15 Wemos pull down
bool bouton_init_ok = LOW;

unsigned int conf_id  = 0;
int conf_version  = 0;
char conf_ssid[20] = {0};
char conf_pass[20] = {0};
char conf_globpass[20] = {0} ;
char conf_nomhost[20] = {0};
char conf_site_ip[10] = {0};
char conf_serv_ntp[20] = {0};
char conf_horaire[70] = {0};
int conf_invisible  = 0;
int conf_canal  = 6;
int conf_max  = 5;
char conf_ftpuser[20] = {0};
char conf_ftppass[20] = {0};
char conf_source_ssid[20] = {0};
char conf_source_pass[20] = {0};
char conf_source_url[100] = {0};
char conf_source_dossier[20] = {0};

char* def_ssid = "partagette";
char* def_pass = "";
char* def_globpass  = "gnulinux";
char* def_nomhost  = "partagette";
char* def_site_ip = "192.168.4.1";
char* def_horaire  = "0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23";// heures d'emission
char* def_ftpuser  = "toto";
char* def_ftppass  = "gnulinux";
char* def_source_ssid = "PARTAGEUSE";
char* def_source_pass = "1234567890";
char* def_source_url = "http://192.168.4.3/public";
char* def_source_dossier = "";
char* def_serv_ntp = ""; //FreeWifi";

//
char* nomssid  = {0};
char* passssid = {0};
char* nomhost  = {0};
int param_version = 1;
int param_version_flash = 1;
unsigned int CHIP_ID = 0;
String repertoire = "";
char* ssid_biblio = "PARTAGEUSE";   // SSID ou chercher les pages
char* password_biblio = "1234567890"; // si existe
String http_site = "http://192.168.4.3/public"; // site web par defaut ou trouver les pages
//String http_site = "http://surla.zone/public"; // site web par defaut ou trouver les pages
//String http_site = "http://insitu.site/public"; // site web par defaut ou trouver les pages
String ftp_user = "toto";
String ftp_pass = "gnulinux";
String pass_global = "";
String pass_global_config = "gnulinux";
int http_port = 80;
int canal_wifi = 1;    // channel 1-13
int invisible = 0;     // 1 = invisible 0 = visible
int max_connexion = 8; // 4-8 ?
char* horaires = "0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23";  // heures d'emission ex :9,10,11,12,13,18,19,20
const char *file_param = "/prtgeuse.json"; // .txt passe bien sur les serveurs http
//const size_t bufferLen = 81;
const byte BUFFER_SIZE = 80;
//char buff[bufferLen];
int nbr_fic = 0 ;        //nbr de fichier de la flash
String bonheure = "" ;
bool ecrit = false;     // sauve si modif
bool grandchef = false; // mode admin
FtpServer ftpSrv; //set #define FTP_DEBUG in ESP8266FtpServer.h to see ftp verbose on serial

const int MAX_NBR_SPOT = 3; // nbr de point acces offrant un ntp
char SpotWiFi[MAX_NBR_SPOT][20] = {"FreeWifi", "VilleSaintNazaire"};
const int timeZone = 2;     // west European Time
WiFiUDP Udp;
unsigned int localPort = 8888;  // local port to listen for UDP packets
IPAddress timeServer(0, 0, 0, 0);

Ticker tickheure;
Ticker tick_led;
RtcDateTime maintenant;

File fsUploadFile;
File list_file;
File f_log;
WiFiEventHandler stationConnectedHandler;
WiFiEventHandler stationDisconnectedHandler;

#define DEBUG
void tickled() {
  //toggle state
  int state = digitalRead(BUILTIN_LED);  // get the current state of GPIO1 pin
  digitalWrite(BUILTIN_LED, !state);     // set pin to the opposite state
}
void returnOK() {
  server.send(200, "text/plain", "");
}
void onStationConnected(const WiFiEventSoftAPModeStationConnected& evt) {
  f_log = SPIFFS.open("/log", "a");
  f_log.print(DonneDate());
  f_log.print(" C ");
  f_log.print(macToString(evt.mac));
  //f_log.print(" ");
  //f_log.print(evt.rssi); //WiFiEventSoftAPModeProbeRequestReceived& !
  f_log.println("");
  f_log.close();
}
void onStationDisconnected(const WiFiEventSoftAPModeStationDisconnected& evt) {
  f_log = SPIFFS.open("/log", "a");
  f_log.print(DonneDate());
  f_log.print(" D ");
  f_log.print(macToString(evt.mac));
  //f_log.print(" ");
  //f_log.print(evt.rssi);
  f_log.println("");
  f_log.close();
}
/////////////////////////////////// init  ////////////////////////////
void setup(void) {

  pinMode(BUILTIN_LED, OUTPUT);
  pinMode(bouton_init , INPUT);
  Serial.begin(115200);
  Serial.print(F("\n"));
  Serial.setDebugOutput(true);
  delay(1000);
  CHIP_ID = ESP.getChipId();
  Serial.print(F("ID "));
  Serial.println(CHIP_ID);
  SPIFFS.begin();
  //// Premier lancement ////

  ///////
  bouton_init_ok = digitalRead(bouton_init);
  if (bouton_init_ok == HIGH || analogRead(A0) > 10 ) {
    bouton_init_ok = HIGH;
    Serial.println(F("init"));
    if (!SPIFFS.exists("/prtgeuse.json") && !SPIFFS.exists("/prtgeuse.txt")) {
      Serial.println(F("Reset"));
      tick_led.attach(0.4, tickled); //pulse
      cmd_format();
      delay(1000);
    }
    Ecrit_config();
  } else {
    tick_led.detach();
    tick_led.attach(0.7, tickled); //pulse
  }
  WiFi.softAPdisconnect(true);
  WiFi.disconnect(); // ??
  //delay(5000);
  //Serial.println("dac");
  repertoire = "";
  ////////////////////////
  // recupere param_version de la flash avant connexion
  Relit_config();
  ///////////init heure RCT ou ntp///////////////////////
  if (strlen(conf_serv_ntp) > 2) { // serv_ntp present => heure ntp
    Serial.println("heure NTP");
    heure_ntp(); // cherche date sur le reseau
  } else {
    Serial.println("heure RTC");
    heure_rtc();
  }
  Serial.println(DonneDate());
  ///////////////////////////////////
  f_log = SPIFFS.open("/log", "a");
  f_log.println(DonneDate());
  f_log.println(" B");
  f_log.close();
  delay(300);
  Serial.println(F("dir flash"));
  Dir dir = SPIFFS.openDir("/");
  while (dir.next()) {
    String fileName = dir.fileName();
    size_t fileSize = dir.fileSize();
    Serial.printf("FS File:%s, size:%s\n", fileName.c_str(), formatBytes(fileSize).c_str());
  }
  //////////////////////////////
  if (bouton_init_ok == LOW) Test_horaires();    //// si pas dans l'heure deepsleep
  Serial.print(F("Point d acces..."));
  //delay(500);

  /*
     Set up an access point
    @param ssid              Pointer to the SSID (max 63 char).
    @param passphrase        (for WPA2 min 8 char, for open use NULL)
    @param channel           WiFi channel number, 1 - 13.
    @param ssid_hidden       Network cloaking (0 = broadcast SSID, 1 = hide SSID)
    @param max_connection    Max simultaneous connected clients, 1 - 4.
  */
  if (max_connexion < 1 || max_connexion > 8) max_connexion = 4 ;
  if (invisible = ! 1) invisible = 0 ;
  if (canal_wifi < 1 || canal_wifi > 13) canal_wifi = 1 ;
  WiFi.mode(WIFI_AP);
  WiFi.softAPConfig(serveurIP, serveurIP, netMsk);
  if (conf_pass != "") {
    WiFi.softAP(conf_ssid, NULL, canal_wifi, invisible, max_connexion);
    delay(500);
    Serial.print("ouverture de ");
    Serial.println(conf_ssid);
  } else {
    WiFi.softAP(conf_ssid, conf_pass, canal_wifi, invisible, max_connexion);
    delay(500);
    Serial.print("ouverture paswd de ");
    Serial.print(conf_ssid);
    Serial.print(" ");
    Serial.println(conf_pass);
  }
  // log
  // Register event handlers.
  // Callback functions will be called as long as these handler objects exist.
  // Call "onStationConnected" each time a station connects
  stationConnectedHandler = WiFi.onSoftAPModeStationConnected(&onStationConnected);
  stationDisconnectedHandler = WiFi.onSoftAPModeStationDisconnected(&onStationDisconnected);
  delay(100);
  // Setup the DNS server redirecting all the domains to the apIP
  dnsServer.setErrorReplyCode(DNSReplyCode::NoError);
  dnsServer.start(DNS_PORT, "*", apIP);
  Serial.print("AP IP address:");
  Serial.println(WiFi.softAPIP());
  delay(500);
  tick_led.detach();
  tick_led.attach(5, tickled); //pulse
  //SERVER INIT
  tickheure.attach(900, Test_horaires); // toutes les 15 min test si deepsleep
  ///////////////////////fonction serveur http///////////////////////////////
  //list directory
  server.on("/list", HTTP_GET,    printDirectory);
  server.on("/edit", HTTP_DELETE, handleFileDelete);
  server.on("/edit", HTTP_PUT,    handleFileCreate);
  server.on("/edit", HTTP_POST, []() {
    returnOK();
  }, handleFileUpload);
  //////////// detection de portail ////
  server.on("/success.txt", affiche_page_portail ); // firefox
  server.on("/generate_204", affiche_page_portail  ); // chrome old
  server.on("/connectivitycheck.android.com", affiche_page_portail ) ; // chrome
  server.on("/hotspot-detect.html", affiche_page_portail ); // ios
  server.on("/ncsi.txt", affiche_page_portail ); // win
  //////////////
  //// mode commande http://truc/cmd?commande=... ////
  server.on("/cmd", HTTP_GET, cmd_parse);
  //server.on("/cmd_ntp"     , cmd_heure_ntp);
  server.on("/cmd_ftpon"    , cmd_ftpon);
  server.on("/fichier", HTTP_GET, fichierList);

  //get heap status, analog input value and all GPIO statuses in one json call
  server.on("/gpio_all", HTTP_GET, []() {
    String json = "{";
    json += "\"heap\":" + String(ESP.getFreeHeap());
    json += ", \"analog\":" + String(analogRead(A0));
    json += ", \"gpio\":" + String((uint32_t)(((GPI | GPO) & 0xFFFF) | ((GP16I & 0x01) << 16)));
    json += "}";
    server.send(200, "text/json", json);
    json = String();
  });
  //// donne date heure ////
  server.on("/date", HTTP_GET, []() {
    String maintenant = DonneDate();
    server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
    server.sendHeader("Pragma", "no-cache");
    server.sendHeader("Expires", "-1");
    server.sendHeader("Content-Length", String(maintenant.length()));
    server.send(200, "text/plain", maintenant);
    Serial.print("date ");
    Serial.println(maintenant);
  });
  ////////////////mecanique du portail /////////////////
  //called when the url is not defined here
  //use it to load content from SPIFFS
  server.onNotFound([]() {
    if (!handleFileRead(server.uri()))
      //server.send(404, "text/plain", "FileNotFound");
      affiche_page_portail;
  });

  //////////////// start serveur /////////////
  server.begin();
  Serial.println(F("HTTP server started"));
}
void loop(void) {
  dnsServer.processNextRequest();
  if (ftpon == true)  ftpSrv.handleFTP(); //make sure in loop you call handleFTP()!!
  server.handleClient();
}
